﻿XIncludeFile "WebGadgetExtras.pb"
;
ButtonWidth = 60 : ButtonHeight = 18 : ButtonLineHeight = ButtonHeight + 6
;
MyWindow=OpenWindow(#PB_Any,0,0,600,400,"WebgadgetLibrary demo",#PB_Window_ScreenCentered|#PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget | #PB_Window_TitleBar) 
If CreateGadgetList(WindowID(MyWindow))=0:End:EndIf
;
WebGadget = WebGadget(#PB_Any,0,0,WindowWidth(MyWindow),WindowHeight(MyWindow)-ButtonLineHeight,"about:blank")
;
HTMLSample$ = "<html><head></head><body><div align="+Chr(34)+"center"+Chr(34)+"><p>WebGadget Library demo</p><p>&nbsp;</p><p>By Fr34k And Zapman</p></div></body></html>"
SetDocumentHTMLContent(WebGadget,HTMLSample$)
;
HPos = 5
ButtonFind = ButtonGadget(#PB_Any,HPos,WindowHeight(MyWindow)-ButtonHeight-2,ButtonWidth,ButtonHeight,"Find")
HPos + ButtonWidth +10
ComboContent = ComboBoxGadget(#PB_Any,HPos,WindowHeight(MyWindow)-ButtonHeight-4,100,100)
AddGadgetItem(ComboContent,-1,"Element 0 infos")
AddGadgetItem(ComboContent,-1,"Element 1 infos")
AddGadgetItem(ComboContent,-1,"Element 2 infos")
AddGadgetItem(ComboContent,-1,"Element 3 infos")
AddGadgetItem(ComboContent,-1,"Element 4 infos")
AddGadgetItem(ComboContent,-1,"Element 5 infos")
AddGadgetItem(ComboContent,-1,"Element 6 infos")
AddGadgetItem(ComboContent,-1,"Element 7 infos")
SetGadgetState(ComboContent,0)
HPos  +102
ButtonDisplay = ButtonGadget(#PB_Any,HPos,WindowHeight(MyWindow)-ButtonHeight-2,ButtonWidth,ButtonHeight,">>Display")
HPos  + ButtonWidth + 10
ButtonEdit = ButtonGadget(#PB_Any,HPos,WindowHeight(MyWindow)-ButtonHeight-2,80,ButtonHeight,"Edit mode")
HPos  + 80 + 10
ButtonRankSpirit = ButtonGadget(#PB_Any,HPos,WindowHeight(MyWindow)-ButtonHeight-2,ButtonWidth,ButtonHeight,"RankSpirit")
HPos  + ButtonWidth + 40
MouseText = TextGadget(#PB_Any,HPos,WindowHeight(MyWindow)-ButtonHeight,130,ButtonHeight,"Last clic was over...")

EditMode$ = "Off"
Repeat  
  ;
  EventID = WaitWindowEvent()
  If  EventID = #PB_Event_CloseWindow
    Quit = 1
  ElseIf EventID=#WM_SIZE
    ResizeGadget(WebGadget,#PB_Ignore,#PB_Ignore,WindowWidth(MyWindow),WindowHeight(MyWindow)-ButtonLineHeight)
    ResizeGadget(ButtonFind,#PB_Ignore,WindowHeight(MyWindow)-ButtonHeight-2,#PB_Ignore,#PB_Ignore)
    ResizeGadget(ComboContent,#PB_Ignore,WindowHeight(MyWindow)-ButtonHeight-4,#PB_Ignore,#PB_Ignore)
    ResizeGadget(ButtonDisplay,#PB_Ignore,WindowHeight(MyWindow)-ButtonHeight-2,#PB_Ignore,#PB_Ignore)
    ResizeGadget(ButtonEdit,#PB_Ignore,WindowHeight(MyWindow)-ButtonHeight-2,#PB_Ignore,#PB_Ignore)
    ResizeGadget(ButtonRankSpirit,#PB_Ignore,WindowHeight(MyWindow)-ButtonHeight-2,#PB_Ignore,#PB_Ignore)
    ResizeGadget(MouseText,#PB_Ignore,WindowHeight(MyWindow)-ButtonHeight,#PB_Ignore,#PB_Ignore)
  ElseIf EventID = #WM_LBUTTONDOWN
    GetWindowRect_(GadgetID(WebGadget),re.RECT) 
    GetCursorPos_(pt.POINT)
    ;
    If pt\y<re\bottom
      pt\x - re\left
      pt\y - re\top
      x = pt\X
      y = pt\y
      GetElementInfosFromPoint(WebGadget,x,y,@Element.ElementInfo)
      SetGadgetText(MouseText,"Last clic was over: "+Element.ElementInfo\tagname)
      SetGadgetState(ComboContent,Element\Index)
    EndIf
    
  ElseIf EventID=#PB_Event_Gadget
    If EventGadget() = ButtonFind
      SearchString$ = InputRequester("Search","Enter the expression to search:","Zapman")
      If SearchString$
        FindInWebGadget(SearchString$,0,WebGadget)
      EndIf
    ElseIf EventGadget() = ButtonDisplay
      Index = GetGadgetState(ComboContent)
      If Index<0 : Index = 0 : EndIf
      GetElementInfosFromIndex(WebGadget,Index,Element.ElementInfo)
      tx$ = "TagPosition: "+Element\taglist+Chr(13)
      tx$ + "posX: "+Str(Element\offsetTop)+Chr(13)
      tx$ + "posY: "+Str(Element\offsetLeft)+Chr(13)+Chr(13)
      tx$ + "Content: "+ Element\outerHTML
      MessageRequester("Element 1 content",tx$,0)
    ElseIf EventGadget() = ButtonEdit
      If EditMode$ = "Off"
        EditMode$ = "On"
        SetGadgetText(ButtonEdit,"Browser Mode")
      Else
        EditMode$ = "Off"
        SetGadgetText(ButtonEdit,"Edit Mode")
      EndIf
      SetWebGadgetEditable(WebGadget,EditMode$)
    ElseIf EventGadget() = ButtonRankSpirit
      SetGadgetText(WebGadget,"about:<body><h1>Loading...</h1></body>")
      While WindowEvent() : Wend
      SetGadgetText(WebGadget,"http://www.rankspirit.com")
      SetWebGadgetEditable(WebGadget,EditMode$)
        
    EndIf
  EndIf
Until Quit
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 45
; FirstLine = 7
; Folding = -
; EnableUnicode
; EnableXP